/* animate-timer.c generated by valac 0.14.1, the Vala compiler
 * generated from animate-timer.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2011,2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Robert Ancell <robert.ancell@canonical.com>
 *          Michael Terry <michael.terry@canonical.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>


#define TYPE_ANIMATE_TIMER (animate_timer_get_type ())
#define ANIMATE_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANIMATE_TIMER, AnimateTimer))
#define ANIMATE_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANIMATE_TIMER, AnimateTimerClass))
#define IS_ANIMATE_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANIMATE_TIMER))
#define IS_ANIMATE_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANIMATE_TIMER))
#define ANIMATE_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANIMATE_TIMER, AnimateTimerClass))

typedef struct _AnimateTimer AnimateTimer;
typedef struct _AnimateTimerClass AnimateTimerClass;
typedef struct _AnimateTimerPrivate AnimateTimerPrivate;

#define ANIMATE_TIMER_TYPE_SPEED (animate_timer_speed_get_type ())

struct _AnimateTimer {
	GObject parent_instance;
	AnimateTimerPrivate * priv;
};

struct _AnimateTimerClass {
	GObjectClass parent_class;
};

typedef enum  {
	ANIMATE_TIMER_SPEED_INSTANT,
	ANIMATE_TIMER_SPEED_FAST,
	ANIMATE_TIMER_SPEED_NORMAL,
	ANIMATE_TIMER_SPEED_SLOW
} AnimateTimerSpeed;

struct _AnimateTimerPrivate {
	AnimateTimerSpeed _speed;
	guint timeout;
	GTimeSpan start_time;
	GTimeSpan length;
};


static gpointer animate_timer_parent_class = NULL;

GType animate_timer_get_type (void) G_GNUC_CONST;
GType animate_timer_speed_get_type (void) G_GNUC_CONST;
#define ANIMATE_TIMER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ANIMATE_TIMER, AnimateTimerPrivate))
enum  {
	ANIMATE_TIMER_DUMMY_PROPERTY,
	ANIMATE_TIMER_SPEED,
	ANIMATE_TIMER_IS_RUNNING
};
AnimateTimer* animate_timer_new (AnimateTimerSpeed speed);
AnimateTimer* animate_timer_construct (GType object_type, AnimateTimerSpeed speed);
void animate_timer_reset (AnimateTimer* self);
void animate_timer_stop (AnimateTimer* self);
static gboolean animate_timer_animate_cb (AnimateTimer* self);
static gboolean _animate_timer_animate_cb_gsource_func (gpointer self);
AnimateTimerSpeed animate_timer_get_speed (AnimateTimer* self);
static gdouble animate_timer_normalize_time (AnimateTimer* self);
static gdouble animate_timer_normalize_progress (AnimateTimer* self, gdouble time);
static void animate_timer_set_speed (AnimateTimer* self, AnimateTimerSpeed value);
gboolean animate_timer_get_is_running (AnimateTimer* self);
static void animate_timer_finalize (GObject* obj);
static void _vala_animate_timer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_animate_timer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType animate_timer_speed_get_type (void) {
	static volatile gsize animate_timer_speed_type_id__volatile = 0;
	if (g_once_init_enter (&animate_timer_speed_type_id__volatile)) {
		static const GEnumValue values[] = {{ANIMATE_TIMER_SPEED_INSTANT, "ANIMATE_TIMER_SPEED_INSTANT", "instant"}, {ANIMATE_TIMER_SPEED_FAST, "ANIMATE_TIMER_SPEED_FAST", "fast"}, {ANIMATE_TIMER_SPEED_NORMAL, "ANIMATE_TIMER_SPEED_NORMAL", "normal"}, {ANIMATE_TIMER_SPEED_SLOW, "ANIMATE_TIMER_SPEED_SLOW", "slow"}, {0, NULL, NULL}};
		GType animate_timer_speed_type_id;
		animate_timer_speed_type_id = g_enum_register_static ("AnimateTimerSpeed", values);
		g_once_init_leave (&animate_timer_speed_type_id__volatile, animate_timer_speed_type_id);
	}
	return animate_timer_speed_type_id__volatile;
}


AnimateTimer* animate_timer_construct (GType object_type, AnimateTimerSpeed speed) {
	AnimateTimer * self = NULL;
	AnimateTimerSpeed _tmp0_;
	_tmp0_ = speed;
	self = (AnimateTimer*) g_object_new (object_type, "speed", _tmp0_, NULL);
	return self;
}


AnimateTimer* animate_timer_new (AnimateTimerSpeed speed) {
	return animate_timer_construct (TYPE_ANIMATE_TIMER, speed);
}


static gboolean _animate_timer_animate_cb_gsource_func (gpointer self) {
	gboolean result;
	result = animate_timer_animate_cb (self);
	return result;
}


void animate_timer_reset (AnimateTimer* self) {
	guint _tmp0_ = 0U;
	gint64 _tmp1_ = 0LL;
	AnimateTimerSpeed _tmp2_;
	g_return_if_fail (self != NULL);
	animate_timer_stop (self);
	_tmp0_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 16, _animate_timer_animate_cb_gsource_func, g_object_ref (self), g_object_unref);
	self->priv->timeout = _tmp0_;
	_tmp1_ = g_get_monotonic_time ();
	self->priv->start_time = (GTimeSpan) _tmp1_;
	_tmp2_ = self->priv->_speed;
	switch (_tmp2_) {
		default:
		case ANIMATE_TIMER_SPEED_INSTANT:
		{
			self->priv->length = 150 * G_TIME_SPAN_MILLISECOND;
			break;
		}
		case ANIMATE_TIMER_SPEED_FAST:
		{
			self->priv->length = 250 * G_TIME_SPAN_MILLISECOND;
			break;
		}
		case ANIMATE_TIMER_SPEED_NORMAL:
		{
			self->priv->length = 500 * G_TIME_SPAN_MILLISECOND;
			break;
		}
		case ANIMATE_TIMER_SPEED_SLOW:
		{
			self->priv->length = 1000 * G_TIME_SPAN_MILLISECOND;
			break;
		}
	}
}


void animate_timer_stop (AnimateTimer* self) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->timeout;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = self->priv->timeout;
		g_source_remove (_tmp1_);
	}
	self->priv->timeout = (guint) 0;
}


static gboolean animate_timer_animate_cb (AnimateTimer* self) {
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gdouble time;
	gdouble _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble progress;
	gdouble _tmp3_;
	gdouble _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = animate_timer_normalize_time (self);
	time = _tmp0_;
	_tmp1_ = time;
	_tmp2_ = animate_timer_normalize_progress (self, _tmp1_);
	progress = _tmp2_;
	_tmp3_ = progress;
	g_signal_emit_by_name (self, "animate", _tmp3_);
	_tmp4_ = progress;
	if (_tmp4_ >= 1.0) {
		self->priv->timeout = (guint) 0;
		result = FALSE;
		return result;
	} else {
		result = TRUE;
		return result;
	}
}


static gdouble animate_timer_normalize_time (AnimateTimer* self) {
	gdouble result = 0.0;
	gint64 _tmp0_ = 0LL;
	gint64 now;
	GTimeSpan _tmp1_;
	GTimeSpan _tmp2_;
	gdouble _tmp3_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = g_get_monotonic_time ();
	now = _tmp0_;
	_tmp1_ = self->priv->start_time;
	_tmp2_ = self->priv->length;
	_tmp3_ = CLAMP (((gdouble) (now - _tmp1_)) / _tmp2_, 0.0, 1.0);
	result = _tmp3_;
	return result;
}


static gdouble animate_timer_normalize_progress (AnimateTimer* self, gdouble time) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = time;
	_tmp1_ = cos (G_PI * _tmp0_);
	_tmp2_ = CLAMP ((((-1) * _tmp1_) + 1) / 2, 0.0, 1.0);
	result = _tmp2_;
	return result;
}


AnimateTimerSpeed animate_timer_get_speed (AnimateTimer* self) {
	AnimateTimerSpeed result;
	AnimateTimerSpeed _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_speed;
	result = _tmp0_;
	return result;
}


static void animate_timer_set_speed (AnimateTimer* self, AnimateTimerSpeed value) {
	AnimateTimerSpeed _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_speed = _tmp0_;
	g_object_notify ((GObject *) self, "speed");
}


gboolean animate_timer_get_is_running (AnimateTimer* self) {
	gboolean result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->timeout;
	result = _tmp0_ != ((guint) 0);
	return result;
}


static void animate_timer_class_init (AnimateTimerClass * klass) {
	animate_timer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AnimateTimerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_animate_timer_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_animate_timer_set_property;
	G_OBJECT_CLASS (klass)->finalize = animate_timer_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ANIMATE_TIMER_SPEED, g_param_spec_enum ("speed", "speed", "speed", ANIMATE_TIMER_TYPE_SPEED, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ANIMATE_TIMER_IS_RUNNING, g_param_spec_boolean ("is-running", "is-running", "is-running", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("animate", TYPE_ANIMATE_TIMER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
}


static void animate_timer_instance_init (AnimateTimer * self) {
	self->priv = ANIMATE_TIMER_GET_PRIVATE (self);
	self->priv->timeout = (guint) 0;
	self->priv->start_time = (GTimeSpan) 0;
	self->priv->length = (GTimeSpan) 0;
}


static void animate_timer_finalize (GObject* obj) {
	AnimateTimer * self;
	self = ANIMATE_TIMER (obj);
	G_OBJECT_CLASS (animate_timer_parent_class)->finalize (obj);
}


GType animate_timer_get_type (void) {
	static volatile gsize animate_timer_type_id__volatile = 0;
	if (g_once_init_enter (&animate_timer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AnimateTimerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) animate_timer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AnimateTimer), 0, (GInstanceInitFunc) animate_timer_instance_init, NULL };
		GType animate_timer_type_id;
		animate_timer_type_id = g_type_register_static (G_TYPE_OBJECT, "AnimateTimer", &g_define_type_info, 0);
		g_once_init_leave (&animate_timer_type_id__volatile, animate_timer_type_id);
	}
	return animate_timer_type_id__volatile;
}


static void _vala_animate_timer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	AnimateTimer * self;
	self = ANIMATE_TIMER (object);
	switch (property_id) {
		case ANIMATE_TIMER_SPEED:
		g_value_set_enum (value, animate_timer_get_speed (self));
		break;
		case ANIMATE_TIMER_IS_RUNNING:
		g_value_set_boolean (value, animate_timer_get_is_running (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_animate_timer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	AnimateTimer * self;
	self = ANIMATE_TIMER (object);
	switch (property_id) {
		case ANIMATE_TIMER_SPEED:
		animate_timer_set_speed (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



